{ ************************************** }
{ Main unit for FPC application "Memory" }
{ ************************************** }

unit memory_u1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Menus,
  ExtCtrls, PopupNotifier;

// Types

type
  TImages = array[1 .. 36] of TImage;
  // TForm1
  TForm1 = class(TForm)
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    Image7: TImage;
    Image8: TImage;
    Image9: TImage;
    Image10: TImage;
    Image11: TImage;
    Image12: TImage;
    Image13: TImage;
    Image14: TImage;
    Image15: TImage;
    Image16: TImage;
    Image17: TImage;
    Image18: TImage;
    Image19: TImage;
    Image20: TImage;
    Image21: TImage;
    Image22: TImage;
    Image23: TImage;
    Image24: TImage;
    Image25: TImage;
    Image26: TImage;
    Image27: TImage;
    Image28: TImage;
    Image29: TImage;
    Image30: TImage;
    Image31: TImage;
    Image32: TImage;
    Image33: TImage;
    Image34: TImage;
    Image35: TImage;
    Image36: TImage;
    MainMenu1: TMainMenu;
    Game: TMenuItem;
    Game1: TMenuItem;
    Game2: TMenuItem;
    Help: TMenuItem;
    About: TPopupNotifier;
    GameOver: TPopupNotifier;
    procedure FormCreate(Sender: TObject);
    procedure Game1Click(Sender: TObject);
    procedure Game2Click(Sender: TObject);
    procedure HelpClick(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Image2Click(Sender: TObject);
    procedure Image3Click(Sender: TObject);
    procedure Image4Click(Sender: TObject);
    procedure Image5Click(Sender: TObject);
    procedure Image6Click(Sender: TObject);
    procedure Image7Click(Sender: TObject);
    procedure Image8Click(Sender: TObject);
    procedure Image9Click(Sender: TObject);
    procedure Image10Click(Sender: TObject);
    procedure Image11Click(Sender: TObject);
    procedure Image12Click(Sender: TObject);
    procedure Image13Click(Sender: TObject);
    procedure Image14Click(Sender: TObject);
    procedure Image15Click(Sender: TObject);
    procedure Image16Click(Sender: TObject);
    procedure Image17Click(Sender: TObject);
    procedure Image18Click(Sender: TObject);
    procedure Image19Click(Sender: TObject);
    procedure Image20Click(Sender: TObject);
    procedure Image21Click(Sender: TObject);
    procedure Image22Click(Sender: TObject);
    procedure Image23Click(Sender: TObject);
    procedure Image24Click(Sender: TObject);
    procedure Image25Click(Sender: TObject);
    procedure Image26Click(Sender: TObject);
    procedure Image27Click(Sender: TObject);
    procedure Image28Click(Sender: TObject);
    procedure Image29Click(Sender: TObject);
    procedure Image30Click(Sender: TObject);
    procedure Image31Click(Sender: TObject);
    procedure Image32Click(Sender: TObject);
    procedure Image33Click(Sender: TObject);
    procedure Image34Click(Sender: TObject);
    procedure Image35Click(Sender: TObject);
    procedure Image36Click(Sender: TObject);
  end;

// Global constants

const
  PicsPath = 'pics/';
  DefPic   = '00.jpg';

// Global variables

var
  Form1: TForm1;
  DefFile: string;
  Count, MClick, I1, I2: Integer;
  ImageFiles: array[1 .. 36] of string;
  ImageFound: array[1 .. 36] of Boolean;
  Images: TImages;

implementation

{$R *.lfm}

//
// Start a new Memory game
//

procedure NewGame;

var
  I, F: Integer;
  PicFile: string;
  PicFileUsed: array[1 .. 18] of Integer;
  PicFileOk: Boolean;

begin
  Form1.GameOver.Icon.LoadFromFile(DefFile);              // default pic as icon on "Game over" popup
  if Form1.GameOver.Visible then
    Form1.GameOver.Visible := False;                      // close "Game over" popup
  for F := 1 to 18 do
    PicFileUsed[F] := 0;
  for I := 1 to 36 do
    Images[I].Picture.LoadFromFile(DefFile);               // display default picture
  for I := 1 to 36 do begin                                // for all 36 squares (images)
    repeat
      PicFileOk := True;
      F := Random(18) + 1;                                 // get a random picture file
      if PicFileUsed[F] < 2 then begin                     // every file has to be used twice
        PicFileUsed[F] := PicFileUsed[F] + 1;
        PicFile := IntToStr(F);
        if F < 10 then
          PicFile := '0' + PicFile;
        PicFile := PicsPath + PicFile + '.jpg';
        DoDirSeparators(PicFile);
        ImageFiles[I] := PicFile;                          // store picture files for each square
      end
      else
        PicFileOk := False;
    until PicFileOk;
    ImageFound[I] := False;
  end;
  Count := 0;
  MClick := 1;                                             // next click will be the first one
  I1 := -1; I2 := -2;                                      // "disable" image indexes
end;

//
// Play the Memory game
//

procedure PlayGame(I : Integer);

begin
  if MClick = 1 then begin
    // First click
    if (I1 > 0) and (not ImageFound[I1]) then              // if image (first click before) not yet found...
      Images[I1].Picture.LoadFromFile(DefFile);            // reset to default picture
    if (I2 > 0) and (not ImageFound[I2]) then              // if image (second click before) not yet found...
      Images[I2].Picture.LoadFromFile(DefFile);            // reset to default picture
    Images[I].Picture.LoadFromFile(ImageFiles[I]);         // display first picture (of pair)
    I1 := I;                                               // index of first image clicked
    MClick := 2;                                           // next click will be a second one
  end
  else begin
    // Second click
    I2 := I;                                               // index of second image clicked
    if (I1 <> I2) and
       (ImageFiles[I1] = ImageFiles[I2]) then begin        // picture files are equal (picture pair found)
      ImageFound[I1] := True; ImageFound[I2] := True;
      Count := Count + 1;
      if Count = 18 then
        Form1.GameOver.Visible := True;                    // show "Game over" popup
    end;
    Images[I].Picture.LoadFromFile(ImageFiles[I]);         // display second picture (of pair)
    MClick := 1;                                           // next click will be a first one again
  end;
end;

// -----------------
// TForm1 procedures
// -----------------

//
// Initialize the game at application start
//

procedure TForm1.FormCreate(Sender: TObject);

begin
  DefFile  := PicsPath + DefPic;
  DoDirSeparators(DefFile);
  // Create an array containing the 36 form-images
  Images[1] := Image1; Images[2] := Image2; Images[3] := Image3;
  Images[4] := Image4; Images[5] := Image5; Images[6] := Image6;
  Images[7] := Image7; Images[8] := Image8; Images[9] := Image9;
  Images[10] := Image10; Images[11] := Image11; Images[12] := Image12;
  Images[13] := Image13; Images[14] := Image14; Images[15] := Image15;
  Images[16] := Image16; Images[17] := Image17; Images[18] := Image18;
  Images[19] := Image19; Images[20] := Image20; Images[21] := Image21;
  Images[22] := Image22; Images[23] := Image23; Images[24] := Image24;
  Images[25] := Image25; Images[26] := Image26; Images[27] := Image27;
  Images[28] := Image28; Images[29] := Image29; Images[30] := Image30;
  Images[31] := Image31; Images[32] := Image32; Images[33] := Image33;
  Images[34] := Image34; Images[35] := Image35; Images[36] := Image36;
  Randomize;
  NewGame;
end;

//
// Menu selection: New game
//

procedure TForm1.Game1Click(Sender: TObject);

begin
  NewGame;
end;

//
// Menu selection: Exit application
//

procedure TForm1.Game2Click(Sender: TObject);

begin
    if GameOver.Visible then
      GameOver.Visible := False;                           // close "Game over" popup
  close();
end;

//
// Menu selection: About
//

procedure TForm1.HelpClick(Sender: TObject);

begin
  if not About.Visible then
    About.Visible := True                                  // show "About" popup
  else
    About.Visible := False;
end;

//
// User click on squares (images) 1 - 36
//

procedure TForm1.Image1Click(Sender: TObject);
begin
  PlayGame(1);
end;

procedure TForm1.Image2Click(Sender: TObject);
begin
  PlayGame(2);
end;

procedure TForm1.Image3Click(Sender: TObject);
begin
  PlayGame(3);
end;

procedure TForm1.Image4Click(Sender: TObject);
begin
  PlayGame(4);
end;

procedure TForm1.Image5Click(Sender: TObject);
begin
  PlayGame(5);
end;

procedure TForm1.Image6Click(Sender: TObject);
begin
  PlayGame(6);
end;

procedure TForm1.Image7Click(Sender: TObject);
begin
  PlayGame(7);
end;

procedure TForm1.Image8Click(Sender: TObject);
begin
  PlayGame(8);
end;

procedure TForm1.Image9Click(Sender: TObject);
begin
  PlayGame(9);
end;

procedure TForm1.Image10Click(Sender: TObject);
begin
  PlayGame(10);
end;

procedure TForm1.Image11Click(Sender: TObject);
begin
  PlayGame(11);
end;

procedure TForm1.Image12Click(Sender: TObject);
begin
  PlayGame(12);
end;

procedure TForm1.Image13Click(Sender: TObject);
begin
  PlayGame(13);
end;

procedure TForm1.Image14Click(Sender: TObject);
begin
  PlayGame(14);
end;

procedure TForm1.Image15Click(Sender: TObject);
begin
  PlayGame(15);
end;

procedure TForm1.Image16Click(Sender: TObject);
begin
  PlayGame(16);
end;

procedure TForm1.Image17Click(Sender: TObject);
begin
  PlayGame(17);
end;

procedure TForm1.Image18Click(Sender: TObject);
begin
  PlayGame(18);
end;

procedure TForm1.Image19Click(Sender: TObject);
begin
  PlayGame(19);
end;

procedure TForm1.Image20Click(Sender: TObject);
begin
  PlayGame(20);
end;

procedure TForm1.Image21Click(Sender: TObject);
begin
  PlayGame(21);
end;

procedure TForm1.Image22Click(Sender: TObject);
begin
  PlayGame(22);
end;

procedure TForm1.Image23Click(Sender: TObject);
begin
  PlayGame(23);
end;

procedure TForm1.Image24Click(Sender: TObject);
begin
  PlayGame(24);
end;

procedure TForm1.Image25Click(Sender: TObject);
begin
  PlayGame(25);
end;

procedure TForm1.Image26Click(Sender: TObject);
begin
  PlayGame(26);
end;

procedure TForm1.Image27Click(Sender: TObject);
begin
  PlayGame(27);
end;

procedure TForm1.Image28Click(Sender: TObject);
begin
  PlayGame(28);
end;

procedure TForm1.Image29Click(Sender: TObject);
begin
  PlayGame(29);
end;

procedure TForm1.Image30Click(Sender: TObject);
begin
  PlayGame(30);
end;

procedure TForm1.Image31Click(Sender: TObject);
begin
  PlayGame(31);
end;

procedure TForm1.Image32Click(Sender: TObject);
begin
  PlayGame(32);
end;

procedure TForm1.Image33Click(Sender: TObject);
begin
  PlayGame(33);
end;

procedure TForm1.Image34Click(Sender: TObject);
begin
  PlayGame(34);
end;

procedure TForm1.Image35Click(Sender: TObject);
begin
  PlayGame(35);
end;

procedure TForm1.Image36Click(Sender: TObject);
begin
  PlayGame(36);
end;

end.

